from Plasma import *
from PlasmaTypes import *
from PlasmaKITypes import *
actClickableObject = ptAttribActivator(1, 'Act: Clickable Object')
ObjectMsg = ptAttribString(2, 'Object String')
#do not change these
testObj = None
gWasMuted = 0
kButtonID = 1
kFadeOutID = 2
kAudioID = 3
kIdleID = 4
kFadeInID = 5
#change these to fit your age
clickObj = 'Button'
SDLName = 'SwapPage'
sPages = ('PageZero', 'PageOne')
sFog = ([0, 1000, 1], [0, 1000, 1])
sColors = ([0.5, 0.5, 0.5], [0.0, 0.0, 0.0])
#enable/disable effects (0=disabled, 1=enabled)
linkEffects = 1
#tweak the link effects here if needed
kButtonSeconds = 0.1
kFadeOutSeconds = 1.5
kAudioSeconds = 3.0
kIdleSeconds = 6.0
kFadeInSeconds = 1.5
#set classname and version for your age
class SwapButton(ptModifier,):

    def __init__(self):
        ptModifier.__init__(self)
        self.version = '2'
        print ('__init__%s v.%s' % (self.__class__.__name__,
         self.version))

#do not change anything below this line

    def OnServerInitComplete(self):
        global testObj
        print ('%s: OnServerInitComplete' % self.__class__.__name__)
        try:
            testObj = PtFindSceneobject(clickObj, PtGetAgeName())
        except:
            print 'ERROR: Missing test object'
        ageSDL = PtGetAgeSDL()
        if (ageSDL == None):
            print 'ERROR: Missing SDL'
            return 
        ageSDL.sendToClients(SDLName)
        ageSDL.setFlags(SDLName, 1, 1)
        ageSDL.setNotify(self.key, SDLName, 0.0)



    def OnNotify(self, state, id, events):
        print ('%s: OnNotify called' % self.__class__.__name__)
        if ((id == actClickableObject.id) and state):
            print ('Object %s clicked' % ObjectMsg.value)
            if (ObjectMsg.value == clickObj):
                if linkEffects:
                    PtAtTimeCallback(self.key, kButtonSeconds, kButtonID)
                else:
                    self.ISwapPage()



    def OnTimer(self, id):
        global gWasMuted
        print ('%s: OnTimer: id = %d' % (self.__class__.__name__, id))
        if (id == kButtonID):
            print 'Start fake link out'
            avKey = PtGetLocalAvatar().getKey()
            PtFakeLinkAvatarToObject(avKey, avKey)
            PtFadeOut(kFadeOutSeconds, 1)
            PtAtTimeCallback(self.key, kFadeOutSeconds, kFadeOutID)
        elif (id == kFadeOutID):
            print 'Disable navigation'
            PtSendKIMessage(kDisableKIandBB, 0)
            PtSetGlobalClickability(0)
            PtDisableMouseMovement()
            PtDisableMovementKeys()
            self.ISwapPage()
            PtAtTimeCallback(self.key, kAudioSeconds, kAudioID)
        elif (id == kAudioID):
            print 'Disable audio' #must do this later to allow fake link sound to finish
            audio = ptAudioControl()
            if audio.isMuted():
                gWasMuted = 1
            else:
                gWasMuted = 0
                audio.muteAll()
            PtAtTimeCallback(self.key, kIdleSeconds, kIdleID)
        elif (id == kIdleID):
            print 'Enable audio'
            if (not gWasMuted):
                audio = ptAudioControl()
                audio.unmuteAll()
            print 'Start fake link in'
            avKey = PtGetLocalAvatar().getKey()
            PtFakeLinkAvatarToObject(avKey, avKey)
            PtAtTimeCallback(self.key, kFadeInSeconds, kFadeInID)
        elif (id == kFadeInID):
            PtFadeIn(kFadeInSeconds, 0)
            print 'Enable navigation'
            PtEnableMovementKeys()
            PtEnableMouseMovement()
            PtSetGlobalClickability(1)
            PtSendKIMessage(kEnableKIandBB, 0)



    def ISwapPage(self):
        ageSDL = PtGetAgeSDL()
        loadPage = ageSDL[SDLName][0]
        if loadPage:
            print 'Replace PageOne with PageZero'
            PtPageOutNode(sPages[1])
            PtPageInNode(sPages[0])
            PtFogSetDefLinear(sFog[0][0], sFog[0][1], sFog[0][2])
            PtFogSetDefColor(ptColor(sColors[0][0], sColors[0][1], sColors[0][2], 1.0))
            PtSetClearColor(sColors[0][0], sColors[0][1], sColors[0][2])
            if (type(testObj) != type(None)):
                if testObj.isLocallyOwned():
                    print 'I am game owner, save state 0'
                    ageSDL[SDLName] = (0,)
        else:
            print 'Replace PageZero with PageOne'
            PtPageOutNode(sPages[0])
            PtPageInNode(sPages[1])
            PtFogSetDefLinear(sFog[1][0], sFog[1][1], sFog[1][2])
            PtFogSetDefColor(ptColor(sColors[1][0], sColors[1][1], sColors[1][2], 1.0))
            PtSetClearColor(sColors[1][0], sColors[1][1], sColors[1][2])
            if (type(testObj) != type(None)):
                if testObj.isLocallyOwned():
                    print 'I am game owner, save state 1'
                    ageSDL[SDLName] = (1,)



glue_cl = None
glue_inst = None
glue_params = None
glue_paramKeys = None
try:
    x = glue_verbose
except NameError:
    glue_verbose = 0

def glue_getClass():
    global glue_cl
    if (glue_cl == None):
        try:
            cl = eval(glue_name)
            if issubclass(cl, ptModifier):
                glue_cl = cl
            elif glue_verbose:
                print ('Class %s is not derived from modifier' % cl.__name__)
        except NameError:
            if glue_verbose:
                try:
                    print ('Could not find class %s' % glue_name)
                except NameError:
                    print 'Filename/classname not set!'
    return glue_cl



def glue_getInst():
    global glue_inst
    if (type(glue_inst) == type(None)):
        cl = glue_getClass()
        if (cl != None):
            glue_inst = cl()
    return glue_inst



def glue_delInst():
    global glue_inst
    global glue_cl
    global glue_paramKeys
    global glue_params
    if (type(glue_inst) != type(None)):
        del glue_inst
    glue_cl = None
    glue_params = None
    glue_paramKeys = None



def glue_getVersion():
    inst = glue_getInst()
    ver = inst.version
    glue_delInst()
    return ver



def glue_findAndAddAttribs(obj, glue_params):
    if isinstance(obj, ptAttribute):
        if glue_params.has_key(obj.id):
            if glue_verbose:
                print 'WARNING: Duplicate attribute ids!'
                print ('%s has id %d which is already defined in %s' % (obj.name,
                 obj.id,
                 glue_params[obj.id].name))
        else:
            glue_params[obj.id] = obj
    elif (type(obj) == type([])):
        for o in obj:
            glue_findAndAddAttribs(o, glue_params)

    elif (type(obj) == type({})):
        for o in obj.values():
            glue_findAndAddAttribs(o, glue_params)

    elif (type(obj) == type(())):
        for o in obj:
            glue_findAndAddAttribs(o, glue_params)




def glue_getParamDict():
    global glue_paramKeys
    global glue_params
    if (type(glue_params) == type(None)):
        glue_params = {}
        gd = globals()
        for obj in gd.values():
            glue_findAndAddAttribs(obj, glue_params)

        glue_paramKeys = glue_params.keys()
        glue_paramKeys.sort()
        glue_paramKeys.reverse()
    return glue_params



def glue_getClassName():
    cl = glue_getClass()
    if (cl != None):
        return cl.__name__
    if glue_verbose:
        print ('Class not found in %s.py' % glue_name)
    return None



def glue_getBlockID():
    inst = glue_getInst()
    if (inst != None):
        return inst.id
    if glue_verbose:
        print ('Instance could not be created in %s.py' % glue_name)
    return None



def glue_getNumParams():
    pd = glue_getParamDict()
    if (pd != None):
        return len(pd)
    if glue_verbose:
        print ('No attributes found in %s.py' % glue_name)
    return 0



def glue_getParam(number):
    pd = glue_getParamDict()
    if (pd != None):
        if (type(glue_paramKeys) == type([])):
            if ((number >= 0) and (number < len(glue_paramKeys))):
                return pd[glue_paramKeys[number]].getdef()
            else:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if ((number >= 0) and (number < len(pl))):
                return pl[number].getdef()
            elif glue_verbose:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None



def glue_setParam(id, value):
    pd = glue_getParamDict()
    if (pd != None):
        if pd.has_key(id):
            try:
                pd[id].__setvalue__(value)
            except AttributeError:
                if isinstance(pd[id], ptAttributeList):
                    try:
                        if (type(pd[id].value) != type([])):
                            pd[id].value = []
                    except AttributeError:
                        pd[id].value = []
                    pd[id].value.append(value)
                else:
                    pd[id].value = value
        elif glue_verbose:
            print "setParam: can't find id=",
            print id
    else:
        print 'setParma: Something terribly has gone wrong. Head for the cover.'



def glue_isNamedAttribute(id):
    pd = glue_getParamDict()
    if (pd != None):
        try:
            if isinstance(pd[id], ptAttribNamedActivator):
                return 1
            if isinstance(pd[id], ptAttribNamedResponder):
                return 2
        except KeyError:
            if glue_verbose:
                print ('Could not find id=%d attribute' % id)
    return 0



def glue_isMultiModifier():
    inst = glue_getInst()
    if isinstance(inst, ptMultiModifier):
        return 1
    return 0



def glue_getVisInfo(number):
    pd = glue_getParamDict()
    if (pd != None):
        if (type(glue_paramKeys) == type([])):
            if ((number >= 0) and (number < len(glue_paramKeys))):
                return pd[glue_paramKeys[number]].getVisInfo()
            else:
                print ('glue_getVisInfo: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if ((number >= 0) and (number < len(pl))):
                return pl[number].getVisInfo()
            elif glue_verbose:
                print ('glue_getVisInfo: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None
